@book{gof_1994,
  author         = {Erich Gamma; Richard Helm; Ralph Johnson; John Vlissides},
  publisher      = {Addison-Wesley},
  title          = {Design Patterns: Elements of Reusable Object-Oriented Software},
  year           = {1994},
  isbn           = {0-201-63361-2},
}

@misc{walker:2022,
  author       = {Vicki Walker},
  howpublished = {https://www.redhat.com/architect/14-software-architecture-patterns},
  title        = {14 software architecture design patterns to know},
  year         = {2022}
}

@misc{microsoft:2022,
  author       = {Microsoft},
  howpublished = {https://learn.microsoft.com/en-us/azure/architecture/framework/security/security-patterns},
  title        = {Security patterns},
  year         = {2022}
}

@misc{microsoft:2023,
  author       = {Microsoft},
  howpublished = {https://learn.microsoft.com/en-us/azure/architecture/patterns/},
  title        = {Cloud Design Patterns},
  year         = {2023}
}

@misc{refactoringguru:2023,
  author       = {Refactoring Guru},
  howpublished = {https://refactoring.guru/design-patterns/behavioral-patterns},
  title        = {Behavioral Design Patterns},
  year         = {2023}
}

@misc{refactoringguru_cor:2023,
  author       = {Refactoring Guru},
  howpublished = {https://refactoring.guru/design-patterns/chain-of-responsibility},
  title        = {Chain of Responsibility},
  year         = {2023}
}

@misc{refactoringguru_cmd:2023,
  author       = {Refactoring Guru},
  howpublished = {https://refactoring.guru/design-patterns/command},
  title        = {Command},
  year         = {2023}
}

@misc{oo-interpreter:2006,
  author       = {OODesign},
  howpublished = {https://www.oodesign.com/interpreter-pattern},
  title        = {Interpreter},
  year         = {2006}
}


@online{TUT_AF,
	title = {Design Pattern - Abstract Factory Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/abstract_factory_pattern.htm},
	abstract = {Design Pattern Abstract Factory Pattern - Abstract Factory patterns work around a super-factory which creates other factories. This factory is also called as factory of factories. This type of design pattern comes under creational pattern as this pattern provides one of the best ways to create an object.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Singleton,
	title = {Design Pattern - Singleton Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/singleton_pattern.htm},
	abstract = {Design Pattern Singleton Pattern - Singleton pattern is one of the simplest design patterns in Java. This type of design pattern comes under creational pattern as this pattern provides one of the best ways to create an object.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Builder,
	title = {Design Patterns - Builder Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/builder_pattern.htm},
	abstract = {Design Patterns Builder Pattern - Builder pattern builds a complex object using simple objects and using a step by step approach. This type of design pattern comes under creational pattern as this pattern provides one of the best ways to create an object.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Prototype,
	title = {Design Patterns - Prototype Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/prototype_pattern.htm},
	abstract = {Design Patterns Prototype Pattern - Prototype pattern refers to creating duplicate object while keeping performance in mind. This type of design pattern comes under creational pattern as this pattern provides one of the best ways to create an object.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Adapter,
	title = {Design Patterns - Adapter Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/adapter_pattern.htm},
	abstract = {Design Patterns Adapter Pattern - Adapter pattern works as a bridge between two incompatible interfaces. This type of design pattern comes under structural pattern as this pattern combines the capability of two independent interfaces.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Bridge,
	title = {Design Patterns - Bridge Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/bridge_pattern.htm},
	abstract = {Design Patterns Bridge Pattern - Bridge is used when we need to decouple an abstraction from its implementation so that the two can vary independently. This type of design pattern comes under structural pattern as this pattern decouples implementation class and abstract class by providing a bridge structure between them.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Filter,
	title = {Design Patterns - Filter Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/filter_pattern.htm},
	abstract = {Design Patterns Filter Pattern - Filter pattern or Criteria pattern is a design pattern that enables developers to filter a set of objects using different criteria and chaining them in a decoupled way through logical operations. This type of design pattern comes under structural pattern as this pattern combines multiple criteria to},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Composite,
	title = {Design Patterns - Composite Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/composite_pattern.htm},
	abstract = {Design Patterns Composite Pattern - Composite pattern is used where we need to treat a group of objects in similar way as a single object. Composite pattern composes objects in term of a tree structure to represent part as well as whole hierarchy. This type of design pattern comes under structural pattern as this pattern creates a tre},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Decorator,
	title = {Design Patterns - Decorator Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/decorator_pattern.htm},
	abstract = {Design Patterns Decorator Pattern - Decorator pattern allows a user to add new functionality to an existing object without altering its structure. This type of design pattern comes under structural pattern as this pattern acts as a wrapper to existing class.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Facade,
	title = {Design Patterns - Facade Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/facade_pattern.htm},
	abstract = {Design Patterns Facade Pattern - Facade pattern hides the complexities of the system and provides an interface to the client using which the client can access the system. This type of design pattern comes under structural pattern as this pattern adds an interface to existing system to hide its complexities.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Flyweight,
	title = {Design Patterns - Flyweight Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/flyweight_pattern.htm},
	abstract = {Design Patterns Flyweight Pattern - Flyweight pattern is primarily used to reduce the number of objects created and to decrease memory footprint and increase performance. This type of design pattern comes under structural pattern as this pattern provides ways to decrease object count thus improving the object structure of application.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{TUT_Proxy,
	title = {Design Patterns - Proxy Pattern},
	author = {Tutorialspoint},
	url = {https://www.tutorialspoint.com/design_pattern/proxy_pattern.htm},
	abstract = {Design Patterns Proxy Pattern - In proxy pattern, a class represents functionality of another class. This type of design pattern comes under structural pattern.},
	urldate = {2023-04-23},
	langid = {american},
}

@online{peter_norvig_design_1996,
	title = {Design Patterns in Dynamic Languages},
	url = {http://www.norvig.com/design-patterns/},
	author = {{Peter Norvig}},
	urldate = {2023-04-24},
	date = {1996-05-05},
}